generic-poky/openembedded/packages/udev/udev-084/init

228 lines
5.6 KiB
Bash

#!/bin/sh -e
### BEGIN INIT INFO
# Provides: udev
# Required-Start: mountvirtfs
# Required-Stop:
# Default-Start: S
# Default-Stop:
# Short-Description: Start udevd, populate /dev and load drivers.
### END INIT INFO
# we need to unmount /dev/pts/ and remount it later over the tmpfs
unmount_devpts() {
if mountpoint -q /dev/pts/; then
umount -l /dev/pts/
fi
if mountpoint -q /dev/shm/; then
umount -l /dev/shm/
fi
}
# mount a tmpfs over /dev, if somebody did not already do it
mount_tmpfs() {
if grep -E -q "^[^[:space:]]+ /dev tmpfs" /proc/mounts; then
return
fi
# /dev/.static/dev/ is used by MAKEDEV to access the real /dev/ directory.
# /etc/udev/ is recycled as a temporary mount point because it's the only
# directory which is guaranteed to be available.
mount -n -o bind /dev /etc/udev
if ! mount -n -o size=$tmpfs_size,mode=0755 -t tmpfs tmpfs /dev; then
umount /etc/udev
echo "udev requires tmpfs support, not started."
exit 1
fi
mkdir -p /dev/.static/dev
chmod 700 /dev/.static/
# The mount options in busybox are non-standard...
if test -x /bin/mount.util-linux
then
/bin/mount.util-linux --move /etc/udev /dev/.static/dev
elif test -x /bin/busybox
then
busybox mount -n -o move /etc/udev /dev/.static/dev
else
echo "udev requires an identifiable mount command, not started."
umount /etc/udev
umount /dev
exit 1
fi
}
# I hate this hack. -- Md
make_extra_nodes() {
if [ "$(echo /lib/udev/devices/*)" != "/lib/udev/devices/*" ]; then
cp --preserve=all --recursive --update /lib/udev/devices/* /dev/
fi
[ -e /etc/udev/links.conf ] || return 0
grep '^[^#]' /etc/udev/links.conf | \
while read type name arg1; do
[ "$type" -a "$name" -a ! -e "/dev/$name" -a ! -L "/dev/$name" ] ||continue
case "$type" in
L) ln -s $arg1 /dev/$name ;;
D) mkdir -p /dev/$name ;;
M) mknod -m 600 /dev/$name $arg1 ;;
*) echo "links.conf: unparseable line ($type $name $arg1)" ;;
esac
done
}
supported_kernel() {
case "$(uname -r)" in
2.[012345].*|2.6.[0-9]|2.6.[0-9][!0-9]*) return 1 ;;
2.6.1[01]|2.6.1[01][!0-9]*) return 1 ;;
esac
return 0
}
set_hotplug_handler() {
case "$(uname -r)" in
2.6.1[0-4]|2.6.1[0-4][!0-9]*) HANDLER='/sbin/udevsend' ;;
esac
echo $HANDLER > /proc/sys/kernel/hotplug
}
# shell version of /usr/bin/tty
my_tty() {
[ -x /bin/readlink ] || return 0
[ -e /proc/self/fd/0 ] || return 0
readlink --silent /proc/self/fd/0 || true
}
warn_if_interactive() {
if [ "$RUNLEVEL" = "S" -a "$PREVLEVEL" = "N" ]; then
return
fi
TTY=$(my_tty)
if [ -z "$TTY" -o "$TTY" = "/dev/console" ]; then
return
fi
printf "\n\n\nIt has been detected that the command\n\n\t$0 $*\n\n"
printf "has been run from an interactive shell.\n"
printf "It will probably not do what you expect, so this script will wait\n"
printf "60 seconds before continuing. Press ^C to stop it.\n"
printf "RUNNING THIS COMMAND IS HIGHLY DISCOURAGED!\n\n\n\n"
sleep 60
}
##############################################################################
PATH="/sbin:/bin:/usr/bin"
[ -x /sbin/udevd ] || exit 0
# defaults
tmpfs_size="10M"
udev_root="/dev"
udevd_timeout=30
. /etc/udev/udev.conf
if ! supported_kernel; then
echo "udev requires a kernel >= 2.6.12, not started."
exit 1
fi
if [ ! -e /proc/filesystems ]; then
echo "udev requires a mounted procfs, not started."
exit 1
fi
if ! grep -q '[[:space:]]tmpfs$' /proc/filesystems; then
echo "udev requires tmpfs support, not started."
exit 1
fi
if [ ! -d /sys/class/ ]; then
echo "udev requires a mounted sysfs, not started."
exit 1
fi
if [ ! -e /proc/sys/kernel/hotplug ]; then
echo "udev requires hotplug support, not started."
exit 1
fi
##############################################################################
# When modifying this script, do not forget that between the time that
# the new /dev has been mounted and udevsynthesize has been run there will be
# no /dev/null. This also means that you cannot use the "&" shell command.
case "$1" in
start)
if [ -e "$udev_root/.udev/" ]; then
if mountpoint -q /dev/; then
TMPFS_MOUNTED=1
else
echo ".udev/ already exists on the static $udev_root!"
fi
else
warn_if_interactive
fi
echo "Starting the hotplug events dispatcher" "udevd"
udevd --daemon
set_hotplug_handler
if [ -z "$TMPFS_MOUNTED" ]; then
unmount_devpts
mount_tmpfs
[ -d /proc/1 ] || mount -n /proc
fi
# if this directory is not present /dev will not be updated by udev
mkdir -p /dev/.udev/ /dev/.udev/db/ /dev/.udev/queue/ /dev/.udevdb/
# /dev/null must be created before udevd is started
make_extra_nodes
echo "Synthesizing the initial hotplug events"
udevsynthesize
# wait for the udevd childs to finish
echo "Waiting for /dev to be fully populated"
while [ -d /dev/.udev/queue/ ]; do
sleep 1
udevd_timeout=$(($udevd_timeout - 1))
if [ $udevd_timeout -eq 0 ]; then
# ps axf
break
fi
done
if [ $udevd_timeout -eq 0 ]; then
echo 'timeout'
fi
;;
stop)
echo "Stopping the hotplug events dispatcher" "udevd"
start-stop-daemon --stop --name udevd --quiet --oknodo --retry 5
;;
restart|force-reload)
echo "Stopping the hotplug events dispatcher" "udevd"
if start-stop-daemon --stop --name udevd --quiet --oknodo --retry 5; then
exit 1
fi
echo "Starting the hotplug events dispatcher" "udevd"
udevd --daemon
;;
*)
echo "Usage: /etc/init.d/udev {start|stop|restart|force-reload}"
exit 1
;;
esac
exit 0